sub theme_header
{
print "<html>\n";
print "<head>\n";
print "<title>$_[0]</title>\n";
if ($charset) {
	print "<meta http-equiv=\"Content-Type\" ",
	      "content=\"text/html; Charset=$charset\">\n";
	}
print "</head>\n";

local $bgcolor = defined($tconfig{'cs_page'}) ? $tconfig{'cs_page'} :
		 defined($gconfig{'cs_page'}) ? $gconfig{'cs_page'} : "ffffff";
local $link = defined($tconfig{'cs_link'}) ? $tconfig{'cs_link'} :
	      defined($gconfig{'cs_link'}) ? $gconfig{'cs_link'} : "0000ee";
local $text = defined($tconfig{'cs_text'}) ? $tconfig{'cs_text'} : 
	      defined($gconfig{'cs_text'}) ? $gconfig{'cs_text'} : "000000";
print "<body bgcolor=#$bgcolor link=#$link vlink=#$link text=#$text $_[8]>\n";

if (@_ > 1) {
	# Output a top row of links
	print "<table width=100%><tr>\n";
	if ($ENV{'HTTP_WEBMIN_SERVERS'}) {
		# Webmin servers index link
		print "<td width=5% nowrap><a href='$ENV{'HTTP_WEBMIN_SERVERS'}'>",
		      "$text{'header_servers'}</a></td>\n";
		}
	if (!$_[4]) {
		# Module index link
		local $mi = $module_index_link || "/$module_name/";
		print "<td width=5% nowrap><a href=\"$gconfig{'webprefix'}$mi\">",
		      "$text{'header_module'}</a></td>\n";
		}
	if (ref($_[2]) eq "ARRAY" && !$ENV{'ANONYMOUS_USER'}) {
		# Help link
		print "<td width=5% nowrap>",&hlink($text{'header_help'}, $_[2]->[0], $_[2]->[1]),
		      "</td>\n";
		}
	elsif (defined($_[2]) && !$ENV{'ANONYMOUS_USER'}) {
		# Help link
		print "<td width=5% nowrap>",&hlink($text{'header_help'}, $_[2]),"</td>\n";
		}

	# Module Config link
	if ($_[3]) {
		local %access = &get_module_acl();
		if (!$access{'noconfig'} && !$config{'noprefs'}) {
			local $cprog = $user_module_config_directory ?
					"uconfig.cgi" : "config.cgi";
			print "<td width=5% nowrap><a href=\"$gconfig{'webprefix'}/$cprog?$module_name\">",
			      $text{'header_config'},"</a></td>\n";
			}
		}

	# Extra header stuff
	if ($_[6]) {
		print "<td width=5% nowrap>",join(" ", split(/<br>/, $_[6])),"</td>\n";
		}

	if (!$_[5]) {
		# Logout/switch (if in one module), or webmin index
		local %acl;
		&read_acl(undef, \%acl);
		local $mc = @{$acl{$base_remote_user}} == 1;
		local $nolo = $ENV{'ANONYMOUS_USER'} ||
			      $ENV{'SSL_USER'} || $ENV{'LOCAL_USER'} ||
			      $ENV{'HTTP_USER_AGENT'} =~ /webmin/i;
		if ($gconfig{'gotoone'} && $main::session_id && $mc == 1 &&
		    !$nolo) {
			print "<td align=right><a href='$gconfig{'webprefix'}/session_login.cgi?logout=1'>$text{'main_logout'}</a></td>\n";
			}
		elsif ($gconfig{'gotoone'} && $mc == 1 && !$nolo) {
			print "<td align=right><a href=$gconfig{'webprefix'}/switch_user.cgi>$text{'main_switch'}</a></td>\n";
			}
		else {
			print "<td align=right><a href='$gconfig{'webprefix'}/?cat=$module_info{'category'}'>$text{'header_webmin'}</a></td>\n";
			}
		}
	print "</tr></table>\n";

	# Show version info
	if ($_[9]) {
		print "<table width=100%><tr><td align=center>",
		      "$_[9]</td></tr></table>\n";
		}
	}
}

sub theme_footer
{
print "</body></html>\n";
}

